/* ../include/dacs_config.h.  Generated from config.h.in by configure.  */
/* config.h.in. */

#ifndef _CONFIG_H_
#define _CONFIG_H_

#ifndef ENABLE_FRAME_MEMORY
#define ENABLE_FRAME_MEMORY		1
#endif

#ifdef __GNUC__
#define GCC_VERSION __VERSION__
#endif

#ifndef MAYBE_UNUSED
#define MAYBE_UNUSED	__attribute__ ((__unused__))
#endif

#if __STDC_VERSION__ < 199901L
# if __GNUC__ >= 2
#  define __func__ __FUNCTION__
# else
#  define __func__ "<unknown>"
# endif
#endif

#ifndef __GNUC__
#define __func__	"<unknown>"
#endif

/* Root installation directory for DACS.  */
#define DACS_HOME "/usr"

/* The default DACS configuration file.  */
#define DACS_CONF "/etc/dacs/federations/dacs.conf"

/* The default DACS site configuration file.  */
#define DACS_SITE_CONF "/etc/dacs/federations/site.conf"

/* The default DACS special executables directory.  */
#define DACS_SBIN "/usr/sbin"

/* The default DACS log file.  */
#define DACS_LOG "/var/log/dacs/error_log"

/* Root installation directory for DACS federations.  */
#define FEDERATIONS_ROOT "/etc/dacs/federations"

/* Root installation directory for Apache.  */
#define APACHE_HOME "/build/dacs-gj2tFH/dacs-1.4.38a/ext_lib/apache"

/* Installation directory for DACS commands/utilities.  */
#define DACS_BINDIR		DACS_HOME/**/"/bin"

/* Installation directory for DACS web services.  */
#define CGIBINDIR "/usr/lib/cgi-bin/dacs"

/* A suffix (file name extension) used for installed CGI programs.  */
#define CGI_SUFFIX ""

/* A suffix (file name extension) used for installed non-CGI programs.  */
#define EXE_SUFFIX ""

/* Installation directory for DACS documents, if any.  */
#define HTDOCSDIR "/usr/share/dacs"

/* Full pathname for openssl command.  */
#define OPENSSL_PROG "/usr/bin/openssl"

/* Full pathname for the sendmail command.  */
/* #undef SENDMAIL_PROG */

#ifndef SENDMAIL_ARGS
#define SENDMAIL_ARGS	"-t"
#endif

/* Full pathname of a non-sendmail command.  */
/* #undef MAILER_PROG */

/* Command line argument for a non-sendmail command.  */
/* #undef MAILER_ARGS */

/* Default SSL/TLS cipher list for sslclient/sslserver.  */
/* #undef DEFAULT_CIPHER_LIST */

/* Define if the corresponding authentication module is available.  */
#define ENABLE_APACHE_AUTH 1
#define ENABLE_CAS_AUTH 1
#define ENABLE_CERT_AUTH 1
#define ENABLE_GRID_AUTH 1
#define ENABLE_HTTP_AUTH 1
/* #undef ENABLE_INFOCARD_AUTH */
#define ENABLE_LDAP_AUTH 1
#define ENABLE_NATIVE_AUTH 1
/* #undef ENABLE_NTLM_AUTH */
#define ENABLE_PAM_AUTH 1
#define ENABLE_PASSWD_AUTH 1
#define ENABLE_SIMPLE_AUTH 1
/* #undef ENABLE_TGMA_AUTH */
#define ENABLE_TOKEN_AUTH 1
#define ENABLE_UNIX_AUTH 1

/* Define if the corresponding roles module is available.  */
#define ENABLE_UNIX_ROLES 1
#define ENABLE_LOCAL_ROLES 1

/* Define if the included fts(3) functions are being used.  */
/* #undef ENABLE_FTS */

/* Define if Berkeley DB is available.  */
/* #undef ENABLE_BDB */

/* Define if SQLite is available.  */
/* #undef ENABLE_SQLITE */

/* Define if the real Unix ndbm library is available.  */
/* #undef ENABLE_NDBM */

/* Define if the GNU gdbm library is available in compatibility mode.  */
/* #undef ENABLE_GDBM */

/* Define if the sdbm library is available.  */
/* #undef ENABLE_SDBM */

/* Define if the user info reporting is available.  */
#define ENABLE_USER_INFO 1

/* Define to suppress logging of startup messages.  */
/* #undef ENABLE_HUSH_STARTUP_LOGGING */

/* Define if experimental access tokens are available.  */
#define ENABLE_ACCESS_TOKENS 1

/* Define if URL patterns are allowed in ACL rules.  */
/* #undef ENABLE_RULE_PATTERNS */

/* Define if add-on functionality is needed (and present). */
/* #undef ENABLE_ADDONS */

/* Define if we're built for the corresponding OS.  */
/* #undef DACS_OS_CYGWIN */
/* #undef DACS_OS_SOLARIS */
/* #undef DACS_OS_FREEBSD */
#define DACS_OS_LINUX 1
/* #undef DACS_OS_MACOSX */
/* #undef DACS_OS_UNKNOWN */

/* Define one if the run-time system is a flavour of FreeBSD. */
/* #undef DACS_OS_FREEBSD8 */
/* #undef DACS_OS_FREEBSD9 */
/* #undef DACS_OS_FREEBSD10 */
/* #undef DACS_OS_FREEBSD11 */

/* Define if built for developer testing. */
/* #undef ENABLE_DEVELOPER */

/* Define if barcode support is available and needed. */
/* #undef ENABLE_BARCODE */

/* Define if building on DSS's development environment. */
/* #undef DSS_HOSTED */

/* Define from uname(1) info.  */
#define DACS_BUILD_PLATFORM "Linux/3.16.0-4-loongson-3/mips"

/* Older versions of pam_strerror() didn't take the pam_handle_t argument.  */
#define PAM_STRERROR_USES_PAMH 1

/* Linux-PAM seems to include this but not FreeBSD or Solaris */
#define HAVE_PAM_FAIL_DELAY 1

#ifdef DACS_OS_LINUX
/*
 * Necessary on some Linux platforms to make sure certain functions
 * and declarations are available regardless of subtleties of include
 * file processing order and such.
 * This tested for/defined _BSD_SOURCE until glib 2.20 deprecated that macro.
 */
#ifndef _DEFAULT_SOURCE
#define _DEFAULT_SOURCE
#endif

#ifndef _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

#ifndef _ISOC99_SOURCE
#define _ISOC99_SOURCE
#endif

#endif

/* Define if the GNU readline library is available and was requested.  */
/* #undef HAVE_READLINE */

/* Some Solaris versions don't supply this; if unavailable, use our own. */
#define HAVE_DIRFD 1

/* Some systems use getpass(3), others use getpassphrase(3).  */
#define HAVE_GETPASS 1
/* #undef HAVE_GETPASSPHRASE */

/* Define to 1 if you have the `getaddrinfo' function. */
#define HAVE_GETADDRINFO 1

/* Systems that have shadow passwords may use getspnam(3).  */
#define HAVE_GETSPNAM 1

/* Use our own strsep(3) if one isn't available.  */
#define HAVE_STRSEP 1

/* Use our own strndup(3) if one isn't available.  */
#define HAVE_STRNDUP 1

/* Define to 1 if you have the `strnlen' function. */
#define HAVE_STRNLEN 1

/* Define to 1 if you have the `trunc' function. */
#define HAVE_TRUNC 1

/* Define to 1 if the `closedir' function returns void instead of `int'. */
/* #undef CLOSEDIR_VOID */

/* Define to 1 if you have the `alarm' function. */
#define HAVE_ALARM 1

/* Define to 1 if you have the <arpa/inet.h> header file. */
#define HAVE_ARPA_INET_H 1

/* Define to 1 if you have the `atexit' function. */
#define HAVE_ATEXIT 1

/* Define to 1 if you have the <dirent.h> header file, and it defines `DIR'.
   */
#define HAVE_DIRENT_H 1

/* Define to 1 if you have the `dlfunc' function. */
/* #undef HAVE_DLFUNC */

/* Define to 1 if you don't have `vprintf' but do have `_doprnt.' */
/* #undef HAVE_DOPRNT */

/* Define to 1 if you have the `endgrent' function. */
#define HAVE_ENDGRENT 1

/* Define to 1 if you have the `fchdir' function. */
#define HAVE_FCHDIR 1

/* Define to 1 if you have the <fcntl.h> header file. */
#define HAVE_FCNTL_H 1

/* Define to 1 if you have the `fork' function. */
#define HAVE_FORK 1

/* Define to 1 if you have the `clock_gettime' function. */
#define HAVE_CLOCK_GETTIME 1

/* Define to 1 if you have the `gethostbyaddr' function. */
#define HAVE_GETHOSTBYADDR 1

/* Define to 1 if you have the `getmntinfo' function. */
/* #undef HAVE_GETMNTINFO */

/* Define to 1 if you have the `getmntinfo' function. */
/* #undef HAVE_GETMNTPT */

/* Define to 1 if you have the `getnameinfo' function. */
#define HAVE_GETNAMEINFO 1

/* Define to 1 if you have the `getpagesize' function. */
#define HAVE_GETPAGESIZE 1

/* Define to 1 if you have the `getspnam' function. */
#define HAVE_GETSPNAM 1

/* Define to 1 if the system has the type `in_port_t'. */
/* #undef HAVE_IN_PORT_T */

/* Define to 1 if you have the `inet_aton' function. */
#define HAVE_INET_ATON 1

/* Define to 1 if you have the `inet_ntoa' function. */
#define HAVE_INET_NTOA 1

/* Define to 1 if you have the <inttypes.h> header file. */
#define HAVE_INTTYPES_H 1

/* Define to 1 if you have the `dl' library (-ldl). */
#define HAVE_LIBDL 1

/* Define to 1 if you have the `fetch' library (-lfetch). */
/* #undef HAVE_LIBFETCH */

/* Define to 1 if you have the `lber' library (-llber). */
/* #undef HAVE_LIBLBER */

/* Define to 1 if you have the `ldap' library (-lldap). */
/* #undef HAVE_LIBLDAP */

/* Define to 1 if you have the `m' library (-lm). */
#define HAVE_LIBM 1

/* Define to 1 if you have the `nsl' library (-lnsl). */
/* #undef HAVE_LIBNSL */

/* Define to 1 if you have the `pam' library (-lpam). */
#define HAVE_LIBPAM 1

/* Define to 1 if you have the `socket' library (-lsocket). */
/* #undef HAVE_LIBSOCKET */

/* Define to 1 if you have the `png' library (-lpng). */
/* #undef HAVE_LIBPNG */

/* Define to 1 if you have the `qrencode' library (-lqrencode). */
/* #undef HAVE_LIBQRENCODE */

/* Define to 1 if you have the <limits.h> header file. */
#define HAVE_LIMITS_H 1

/* Define to 1 if you have the <locale.h> header file. */
#define HAVE_LOCALE_H 1

/* Define to 1 if you have the `localtime' function. */
#define HAVE_LOCALTIME 1

/* Define to 1 if you have the `lockf' function. */
#define HAVE_LOCKF 1

/* Define to 1 if `lstat' has the bug that it succeeds when given the
   zero-length file name argument. */
/* #undef HAVE_LSTAT_EMPTY_STRING_BUG */

/* Define to 1 if your system has a GNU libc compatible `malloc' function, and
   to 0 otherwise. */
#define HAVE_MALLOC 1

/* Define to 1 if you have the `memchr' function. */
#define HAVE_MEMCHR 1

/* Define to 1 if you have the `memmove' function. */
#define HAVE_MEMMOVE 1

/* Define to 1 if you have the <memory.h> header file. */
#define HAVE_MEMORY_H 1

/* Define to 1 if you have the `memset' function. */
#define HAVE_MEMSET 1

/* Define to 1 if you have the `mkstemp' function. */
#define HAVE_MKSTEMP 1

/* Define to 1 if you have the `mktime' function. */
#define HAVE_MKTIME 1

/* Define to 1 if you have a working `mmap' system call. */
#define HAVE_MMAP 1

/* Define to 1 if you have a working `posix_memalign' system call. */
#define HAVE_POSIX_MEMALIGN 1

/* Define to 1 if you have the `munmap' function. */
#define HAVE_MUNMAP 1

/* Define to 1 if you have the <ndir.h> header file, and it defines `DIR'. */
/* #undef HAVE_NDIR_H */

/* Define to 1 if you have the <netdb.h> header file. */
#define HAVE_NETDB_H 1

/* Define to 1 if you have the <netinet/in.h> header file. */
#define HAVE_NETINET_IN_H 1

/* Define to 1 if you have the <paths.h> header file. */
#define HAVE_PATHS_H 1

/* Define to 1 if you have the `pow' function. */
#define HAVE_POW 1

/* Define to 1 if the system has the type `ptrdiff_t'. */
#define HAVE_PTRDIFF_T 1

/* Define to 1 if you have the `putenv' function. */
#define HAVE_PUTENV 1

/* Define to 1 if your system has a GNU libc compatible `realloc' function,
   and to 0 otherwise. */
#define HAVE_REALLOC 1

/* Define to 1 if you have the `regcomp' function. */
#define HAVE_REGCOMP 1

/* Define to 1 if you have the `select' function. */
#define HAVE_SELECT 1

/* Define to 1 if you have the `setenv' function. */
#define HAVE_SETENV 1

/* Define to 1 if you have the `setlocale' function. */
#define HAVE_SETLOCALE 1

/* Define to 1 if you have the <shadow.h> header file. */
#define HAVE_SHADOW_H 1

/* Define to 1 if you have a working `shm_open' function. */
#define HAVE_SHM_OPEN 1

/* Define to 1 if you have the `socket' function. */
#define HAVE_SOCKET 1

/* Define to 1 if `stat' has the bug that it succeeds when given the
   zero-length file name argument. */
/* #undef HAVE_STAT_EMPTY_STRING_BUG */

/* Define to 1 if stdbool.h conforms to C99. */
#define HAVE_STDBOOL_H 1

/* Define to 1 if you have the <stddef.h> header file. */
#define HAVE_STDDEF_H 1

/* Define to 1 if you have the <stdint.h> header file. */
#define HAVE_STDINT_H 1

/* Define to 1 if you have the <stdlib.h> header file. */
#define HAVE_STDLIB_H 1

/* Define to 1 if you have the `strcasecmp' function. */
#define HAVE_STRCASECMP 1

/* Define to 1 if you have the `strncasecmp' function. */
#define HAVE_STRNCASECMP 1

/* Define to 1 if you have the `strchr' function. */
#define HAVE_STRCHR 1

/* Define to 1 if you have the `strcspn' function. */
#define HAVE_STRCSPN 1

/* Define to 1 if you have the `strdup' function. */
#define HAVE_STRDUP 1

/* Define to 1 if you have the `strerror' function. */
#define HAVE_STRERROR 1

/* Define to 1 if you have the `strftime' function. */
#define HAVE_STRFTIME 1

/* Define to 1 if you have the <strings.h> header file. */
#define HAVE_STRINGS_H 1

/* Define to 1 if you have the <string.h> header file. */
#define HAVE_STRING_H 1

/* Define to 1 if you have the `strpbrk' function. */
#define HAVE_STRPBRK 1

/* Define to 1 if you have the `strrchr' function. */
#define HAVE_STRRCHR 1

/* Define to 1 if you have the `strspn' function. */
#define HAVE_STRSPN 1

/* Define to 1 if you have the `strstr' function. */
#define HAVE_STRSTR 1

/* Define to 1 if you have the `strcasestr' function. */
#define HAVE_STRCASESTR 1

/* Define to 1 if you have the `strtol' function. */
#define HAVE_STRTOL 1

/* Define to 1 if you have the `strtoul' function. */
#define HAVE_STRTOUL 1

/* Define to 1 if you have the `sysconf' function. */
#define HAVE_SYSCONF 1

/* Define to 1 if you have the `system' function. */
#define HAVE_SYSTEM 1

/* Define to 1 if you have the `isblank' function. */
#define HAVE_ISBLANK 1

/* Define to 1 if `tm_zone' is member of `struct tm'. */
#define HAVE_STRUCT_TM_TM_ZONE 1

/* Define to 1 if you have the <sys/dir.h> header file, and it defines `DIR'.
   */
/* #undef HAVE_SYS_DIR_H */

/* Define to 1 if you have the <sys/ndir.h> header file, and it defines `DIR'.
   */
/* #undef HAVE_SYS_NDIR_H */

/* Define to 1 if you have the <sys/param.h> header file. */
#define HAVE_SYS_PARAM_H 1

/* Define to 1 if you have the <sys/select.h> header file. */
#define HAVE_SYS_SELECT_H 1

/* Define to 1 if you have the <sys/socket.h> header file. */
#define HAVE_SYS_SOCKET_H 1

/* Define to 1 if you have the <sys/stat.h> header file. */
#define HAVE_SYS_STAT_H 1

/* Define to 1 if you have the <sys/time.h> header file. */
#define HAVE_SYS_TIME_H 1

/* Define to 1 if you have the <sys/types.h> header file. */
#define HAVE_SYS_TYPES_H 1

/* Define to 1 if you have the <termios.h> header file. */
#define HAVE_TERMIOS_H 1

/* Define to 1 if you have the `time' function. */
#define HAVE_TIME 1

/* Define to 1 if you have the `timegm' function. */
#define HAVE_TIMEGM 1

/* Define to 1 if your `struct tm' has `tm_zone'. Deprecated, use
   `HAVE_STRUCT_TM_TM_ZONE' instead. */
#define HAVE_TM_ZONE 1

/* Define to 1 if you don't have `tm_zone' but do have the external array
   `tzname'. */
/* #undef HAVE_TZNAME */

/* Define to 1 if you have the `tzset' function. */
#define HAVE_TZSET 1

/* Define to 1 if the system has the type `uint16_t'. */
#define HAVE_UINT16_T 1

/* Define to 1 if you have the `uname' function. */
#define HAVE_UNAME 1

/* Define to 1 if you have the <unistd.h> header file. */
#define HAVE_UNISTD_H 1

/* Define to 1 if you have the `unsetenv' function. */
#define HAVE_UNSETENV 1

/* Define to 1 if you have the `vfork' function. */
#define HAVE_VFORK 1

/* Define to 1 if you have the <vfork.h> header file. */
/* #undef HAVE_VFORK_H */

/* Define to 1 if you have the `vprintf' function. */
#define HAVE_VPRINTF 1

/* Define to 1 if `fork' works. */
#define HAVE_WORKING_FORK 1

/* Define to 1 if `vfork' works. */
#define HAVE_WORKING_VFORK 1

/* Define to 1 if `lstat' dereferences a symlink specified with a trailing
   slash. */
#define LSTAT_FOLLOWS_SLASHED_SYMLINK 1

#if !defined(BUILDING_LOCAL_NTLM_AUTH) && !defined(BUILDING_LOCAL_LDAP_AUTH) && !defined(BUILDING_MOD_AUTH_DACS)
/* Don't define these because they'll conflict with another package */

/* Define to the address where bug reports for this package should be sent. */
#define PACKAGE_BUGREPORT "dacs-bugs@dss.ca"

/* Define to the full name of this package. */
#define PACKAGE_NAME "DACS"

/* Define to the full name and version of this package. */
#define PACKAGE_STRING "DACS 1.4.38a"

/* Define to the one symbol short name of this package. */
#define PACKAGE_TARNAME "dacs"

/* Define to the version of this package. */
#define PACKAGE_VERSION "1.4.38a"
#endif

/* Define as the return type of signal handlers (`int' or `void'). */
#define RETSIGTYPE void

/* Define to the type of arg 1 for `select'. */
#define SELECT_TYPE_ARG1 int

/* Define to the type of args 2, 3 and 4 for `select'. */
#define SELECT_TYPE_ARG234 (fd_set *)

/* Define to the type of arg 5 for `select'. */
#define SELECT_TYPE_ARG5 (struct timeval *)

/* Define to 1 if you have the ANSI C header files. */
#define STDC_HEADERS 1

/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
#define TIME_WITH_SYS_TIME 1

/* Define to 1 if your <sys/time.h> declares `struct tm'. */
/* #undef TM_IN_SYS_TIME */

/* Define to empty if `const' does not conform to ANSI C. */
/* #undef const */

/* Define to `int' if <sys/types.h> doesn't define. */
/* #undef gid_t */

/* Define to `__inline__' or `__inline' if that's what the C compiler
   calls it, or to nothing if 'inline' is not supported under any name.  */
#ifndef __cplusplus
#ifdef __STRICT_ANSI__
#define inline
#else
/* #undef inline */
#endif
#endif

/* Define to rpl_malloc if the replacement function should be used. */
/* #undef malloc */

/* Define to `int' if <sys/types.h> does not define. */
/* #undef pid_t */

/* Define to rpl_realloc if the replacement function should be used. */
/* #undef realloc */

/* Define to `unsigned' if <sys/types.h> does not define. */
/* #undef size_t */

/* Define to `int' if <sys/types.h> doesn't define. */
/* #undef uid_t */

/* Define as `fork' if `vfork' does not work. */
/* #undef vfork */

/* Define to empty if the keyword `volatile' does not work. Warning: valid
   code using `volatile' can become incorrect without. Disable with care. */
/* #undef volatile */

/* Define in case the system doesn't define BYTE_ORDER conveniently. */
#define DACS_OS_BYTE_ORDER DACS_OS_LITTLE_ENDIAN
#define DACS_OS_BIG_ENDIAN	4321	/* MSB first */
#define DACS_OS_LITTLE_ENDIAN	1234	/* LSB first */
/* #undef DACS_OS_IS_BIG_ENDIAN */
#define DACS_OS_IS_LITTLE_ENDIAN 1

/* Sizes, in bytes, of the basic types for the platform/compiler being used. */
#define SIZEOF_CHAR 1
#define SIZEOF_UNSIGNED_CHAR 1
#define SIZEOF_SHORT 2
#define SIZEOF_UNSIGNED_SHORT 2
#define SIZEOF_INT 4
#define SIZEOF_UNSIGNED_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_UNSIGNED_LONG 4
#define SIZEOF_LONG_LONG 8
#define SIZEOF_UNSIGNED_LONG_LONG 8
#define SIZEOF_SIZE_T 4
#define SIZEOF_VOID_P 4

/*
 * Some basic types with explicit sizes - because sometimes we care.
 *
 * We want to end up defining, where available:
 * Types:  DACS_ui{64,32,16,8} and DACS_i{64,32,16,8}
 * Upper Limits: DACS_MAX_{ULONGLONG,ULONG,UINT,USHORT,UCHAR}
 *               DACS_MAX_{LONGLONG,LONG,INT,SHORT,CHAR}
 *               DACS_MAX_UI{64,32,16,8}
 * Lower Limits: DACS_MIN_{LONGLONG,LONG,INT,SHORT,CHAR}
 *               DACS_MIN_I(64,32,16,8}
 */
#if SIZEOF_UNSIGNED_INT == 8
typedef unsigned int DACS_ui64;
#define DACS_UI64_T         unsigned int
#define DACS_MAX_UINT	    (DACS_ui64) 0xffffffffffffffff

#elif SIZEOF_UNSIGNED_LONG == 8
typedef unsigned long DACS_ui64;
#define DACS_UI64_T         unsigned long
#define DACS_MAX_ULONG	    (DACS_ui64) 0xffffffffffffffff

#elif SIZEOF_UNSIGNED_LONG_LONG == 8
typedef unsigned long long DACS_ui64;
#define DACS_UI64_T         unsigned long long
#define DACS_MAX_ULONGLONG  (DACS_ui64) 0xffffffffffffffff

#else
#error "No 8 byte unsigned data type?"
#endif

#if SIZEOF_UNSIGNED_INT == 4
typedef unsigned int DACS_ui32;
#define DACS_UI32_T        unsigned int
#define DACS_MAX_UINT      (DACS_ui32) 0xffffffff

#elif SIZEOF_UNSIGNED_LONG == 4
typedef unsigned long DACS_ui32;
#define DACS_UI32_T        unsigned long
#define DACS_MAX_ULONG	   (DACS_ui32) 0xffffffff

#else
#error "No 4 byte unsigned data type?"
#endif

#if SIZEOF_UNSIGNED_SHORT == 2
typedef unsigned short DACS_ui16;
#define DACS_UI16_T        unsigned short
#define DACS_MAX_USHORT   (DACS_ui16) 0xffff

#elif SIZEOF_UNSIGNED_INT == 2
typedef unsigned int DACS_ui16;
#define DACS_UI16_T        unsigned int
#define DACS_MAX_UINT      (DACS_ui16) 0xffff

#else
#error "No 2 byte unsigned data type?"
#endif

#if SIZEOF_UNSIGNED_CHAR == 1
typedef unsigned char DACS_ui8;
#define DACS_UI8_T        unsigned char
#define DACS_MAX_UCHAR    (DACS_ui8) 0xff

#else
#error "No 1 byte unsigned data type?"
#endif


#if SIZEOF_INT == 8
typedef int DACS_i64;
#define DACS_I64_T         int
#define DACS_MAX_INT       (DACS_i64) (0x7fffffffffffffff)
#define DACS_MIN_INT       (DACS_i64) (0x8000000000000000)

#elif SIZEOF_LONG == 8
typedef long DACS_i64;
#define DACS_I64_T         long
#define DACS_MAX_LONG      (DACS_i64) (0x7fffffffffffffff)
#define DACS_MIN_LONG      (DACS_i64) (0x8000000000000000)

#elif SIZEOF_LONG_LONG == 8
typedef long long DACS_i64;
#define DACS_I64_T         long long
#define DACS_MAX_LONGLONG  (DACS_i64) (0x7fffffffffffffff)
#define DACS_MIN_LONGLONG  (DACS_i64) (0x8000000000000000)

#else
#error "No 8 byte signed data type?"
#endif

#if SIZEOF_INT == 4
typedef int DACS_i32;
#define DACS_I32_T         int
#define DACS_MAX_INT	   (DACS_i32) (0x7fffffff)
#define DACS_MIN_INT	   (DACS_i32) (0x80000000)

#elif SIZEOF_LONG == 4
typedef long DACS_i32;
#define DACS_I32_T         long
#define DACS_MAX_LONG	   (DACS_i32) (0x7fffffff)
#define DACS_MIN_LONG	   (DACS_i32) (0x80000000)

#else
#error "No 4 byte signed data type?"
#endif

#if SIZEOF_SHORT == 2
typedef short DACS_i16;
#define DACS_I16_T       short
#define DACS_MAX_SHORT   (DACS_i16) (0x7fff)
#define DACS_MIN_SHORT   (DACS_i16) (0x8000)

#elif SIZEOF_INT == 2
typedef int DACS_i16;
#define DACS_I16_T        int
#define DACS_MAX_INT     (DACS_i16) (0xffff)
#define DACS_MIN_INT     (DACS_i16) (0x8000)

#else
#error "No 2 byte signed data type?"
#endif

#if SIZEOF_CHAR == 1
typedef signed char DACS_i8;
#define DACS_I8_T         char
#define DACS_MAX_CHAR     (DACS_i8) (0x7f)
#define DACS_MIN_CHAR     (DACS_i8) (0x80)

#else
#error "No 1 byte signed data type?"
#endif

#define DACS_MAX_UI64      (DACS_ui64) (0xffffffffffffffff)
#define DACS_MAX_UI32      (DACS_ui32) (0xffffffff)
#define DACS_MAX_UI16      (DACS_ui16) (0xffff)
#define DACS_MAX_UI8       (DACS_ui8)  (0xff)

#define DACS_MAX_I64       (DACS_i64) (0x7fffffffffffffff)
#define DACS_MIN_I64       (DACS_i64) (0x8000000000000000)
#define DACS_MAX_I32       (DACS_i32) (0x7fffffff)
#define DACS_MIN_I32       (DACS_i32) (0x80000000)
#define DACS_MAX_I16       (DACS_i16) (0x7fff)
#define DACS_MIN_I16       (DACS_i16) (0x8000)
#define DACS_MAX_I8        (DACS_i8)  (0x7f)
#define DACS_MIN_I8        (DACS_i8)  (0x80)

/*
 * These names will be defined as the real (un-intercepted) memory allocation
 * functions, in case they need to be called directly.
 * See configure.ac
 */
#define real_malloc bsd_malloc
#define real_calloc bsd_calloc
#define real_valloc bsd_valloc
#define real_free bsd_free
#define real_cfree bsd_cfree
#define real_realloc bsd_realloc

#endif
